-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 44 of the CMF schema. Migration code to be applied on top of the
-- previous version. Technically, the schema isn't changed but we rely on
-- the schema version to trigger running of the ddl files.
--

update SCHEMA_VERSION set VERSION=44;

-- 1) Move roleType level client configs from JOBTRACKER to BASTION

update CONFIGS
    set ROLE_TYPE='BASTION' where 
        ROLE_TYPE='JOBTRACKER' and
        ATTR in ('mapred_map_tasks_speculative_execution',
                 'mapred_reduce_tasks_speculative_execution');

-- 2) Delete remaining JT configs
--    Note that we are discarding JT role instance level configs
--    for simplicity. Remember that neither actually did anything
--    before now.

delete from CONFIGS where
    ROLE_ID is not null and
    ATTR in ('mapred_map_tasks_speculative_execution',
             'mapred_reduce_tasks_speculative_execution');
