-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 04501 of the CMF schema. Migration code to be applied on top of the
-- previous version.
--

update SCHEMA_VERSION set VERSION=04501;

-- New table for parcel metadata.
create table PARCELS (
    PARCEL_ID number constraint NOT_NULL_PARCEL_ID not null,
    PRODUCT varchar(255) constraint NOT_NULL_PARCEL_PRODUCT not null,
    VERSION varchar(255) constraint NOT_NULL_PARCEL_VERSION not null,
    OS varchar(255) constraint NOT_NULL_PARCEL_OS not null,
    FILENAME varchar(255) constraint NOT_NULL_PARCLE_FILENAME not null constraint UNIQUE_PARCEL_FILENAME unique,
    HASH varchar(255) constraint NOT_NULL_PARCLE_HASH not null,
    BINARY_DIFF number(1,0) constraint NOT_NULL_PARCLE_BINARY_DIFF not null,
    BASE_PARCEL_ID number,
    STATUS varchar(255) constraint NOT_NULL_PARCEL_STATUS not null,
    constraint PK_PARCELS primary key (PARCEL_ID)
);

create index IDX_BASE_PARCEL on PARCELS (BASE_PARCEL_ID);

alter table PARCELS
    add constraint FK_BASE_PARCEL
    foreign key (BASE_PARCEL_ID)
    references PARCELS
    deferrable initially immediate;
