-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 4518 of the CMF schema.
-- Add host templates.
--

update SCHEMA_VERSION set VERSION=4518;

create table HOST_TEMPLATES (
  HOST_TEMPLATE_ID number constraint NN_HOST_TEMPLATES_PROCESS_ID not null,
  OPTIMISTIC_LOCK_VERSION number constraint NN_HOST_TEMPLATES_VERSION not null,
  NAME varchar(255) constraint NN_HOST_TEMPLATES_NAME not null,
  CLUSTER_ID number constraint NN_HOST_TEMPLATES_CLUSTER_ID not null,
  primary key (HOST_TEMPLATE_ID)
);

alter table HOST_TEMPLATES
  add constraint FK_HOST_TEMPLATE_CLUSTER
  foreign key (CLUSTER_ID)
  references CLUSTERS (CLUSTER_ID)
  deferrable initially immediate;

create unique index IDX_UNIQUE_HOST_TEMPLATES_NAME on HOST_TEMPLATES (NAME);
create index IDX_HOST_TEMPLATE_CLUSTER on HOST_TEMPLATES (CLUSTER_ID);

create table HOST_TEMPLATE_TO_ROLE_CONF_GRP (
  HOST_TEMPLATE_ID number constraint NN_HOST_TEMPL_TO_RCG_HOST_TEMP not null,
  ROLE_CONFIG_GROUP_ID number constraint NN_HOST_TEMPL_TO_RCG_RCG not null,
  primary key (HOST_TEMPLATE_ID, ROLE_CONFIG_GROUP_ID)
);

alter table HOST_TEMPLATE_TO_ROLE_CONF_GRP
  add constraint FK_HOST_TEMPL_TO_RCG_HOST_TEMP
  foreign key (HOST_TEMPLATE_ID)
  references HOST_TEMPLATES (HOST_TEMPLATE_ID)
  deferrable initially immediate;

alter table HOST_TEMPLATE_TO_ROLE_CONF_GRP
  add constraint FK_HOST_TEMPL_TO_RCG_RCG
  foreign key (ROLE_CONFIG_GROUP_ID)
  references ROLE_CONFIG_GROUPS (ROLE_CONFIG_GROUP_ID)
  deferrable initially immediate;

create index IDX_HOST_TEMPL_TO_RCG_HOST_TMP on HOST_TEMPLATE_TO_ROLE_CONF_GRP (HOST_TEMPLATE_ID);
create index IDX_HOST_TEMPL_TO_RCG_RCG on HOST_TEMPLATE_TO_ROLE_CONF_GRP (ROLE_CONFIG_GROUP_ID);
